/**
 * POCDMT000040Component4.java
 *
 * File generated from the cdaepsos3::POCDMT000040Component4 uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.cdaepsos4;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;
import org.w3c.dom.Document;
import org.w3c.dom.Node;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.*;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import java.util.ArrayList;
import java.util.List;

// End of user code


/**
 * Description of the class POCDMT000040Component4.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "POCD_MT000040.Component4", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"sequenceNumber",
	"seperatableInd",
	"act",
	"encounter",
	"observation",
	"observationMedia",
	"organizer",
	"procedure",
	"regionOfInterest",
	"substanceAdministration",
	"supply",
	"contextConductionInd",
	"nullFlavor",
	"typeCode"
})
@XmlRootElement(name = "POCD_MT000040.Component4")
public class POCDMT000040Component4 implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CS> realmCode;
	@XmlElement(name = "typeId", namespace = "urn:hl7-org:v3")
	public POCDMT000040InfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.II> templateId;
	@XmlElement(name = "sequenceNumber", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.INT sequenceNumber;
	@XmlElement(name = "seperatableInd", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.BL seperatableInd;
	@XmlElement(name = "act", namespace = "urn:hl7-org:v3")
	public POCDMT000040Act act;
	@XmlElement(name = "encounter", namespace = "urn:hl7-org:v3")
	public POCDMT000040Encounter encounter;
	@XmlElement(name = "observation", namespace = "urn:hl7-org:v3")
	public POCDMT000040Observation observation;
	@XmlElement(name = "observationMedia", namespace = "urn:hl7-org:v3")
	public POCDMT000040ObservationMedia observationMedia;
	@XmlElement(name = "organizer", namespace = "urn:hl7-org:v3")
	public POCDMT000040Organizer organizer;
	@XmlElement(name = "procedure", namespace = "urn:hl7-org:v3")
	public POCDMT000040Procedure procedure;
	@XmlElement(name = "regionOfInterest", namespace = "urn:hl7-org:v3")
	public POCDMT000040RegionOfInterest regionOfInterest;
	@XmlElement(name = "substanceAdministration", namespace = "urn:hl7-org:v3")
	public POCDMT000040SubstanceAdministration substanceAdministration;
	@XmlElement(name = "supply", namespace = "urn:hl7-org:v3")
	public POCDMT000040Supply supply;
	@XmlAttribute(name = "contextConductionInd")
	public Boolean contextConductionInd;
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.voc.NullFlavor nullFlavor;
	@XmlAttribute(name = "typeCode")
	public net.ihe.gazelle.voc.ActRelationshipHasComponent typeCode;
	@XmlTransient
	private Object __parent;
	
	void afterUnmarshal( javax.xml.bind.Unmarshaller u, Object parent ){
		this.__parent = parent;
	}
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private Node _xmlNodePresentation;
	
	
	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<net.ihe.gazelle.datatypes.CS> getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<net.ihe.gazelle.datatypes.CS>();
	    }
	    return realmCode;
	}
	
	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<net.ihe.gazelle.datatypes.CS> realmCode) {
	    this.realmCode = realmCode;
	}
	
	
	
	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().add(realmCode_elt);
	}
	
	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().remove(realmCode_elt);
	}
	
	/**
	 * Return typeId.
	 * @return typeId
	 */
	public POCDMT000040InfrastructureRootTypeId getTypeId() {
	    return typeId;
	}
	
	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(POCDMT000040InfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}
	
	
	
	
	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.datatypes.II> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.datatypes.II>();
	    }
	    return templateId;
	}
	
	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.datatypes.II> templateId) {
	    this.templateId = templateId;
	}
	
	
	
	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().add(templateId_elt);
	}
	
	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().remove(templateId_elt);
	}
	
	/**
	 * Return sequenceNumber.
	 * @return sequenceNumber
	 */
	public net.ihe.gazelle.datatypes.INT getSequenceNumber() {
	    return sequenceNumber;
	}
	
	/**
	 * Set a value to attribute sequenceNumber.
	 * @param sequenceNumber.
	 */
	public void setSequenceNumber(net.ihe.gazelle.datatypes.INT sequenceNumber) {
	    this.sequenceNumber = sequenceNumber;
	}
	
	
	
	
	/**
	 * Return seperatableInd.
	 * @return seperatableInd
	 */
	public net.ihe.gazelle.datatypes.BL getSeperatableInd() {
	    return seperatableInd;
	}
	
	/**
	 * Set a value to attribute seperatableInd.
	 * @param seperatableInd.
	 */
	public void setSeperatableInd(net.ihe.gazelle.datatypes.BL seperatableInd) {
	    this.seperatableInd = seperatableInd;
	}
	
	
	
	
	/**
	 * Return act.
	 * @return act
	 */
	public POCDMT000040Act getAct() {
	    return act;
	}
	
	/**
	 * Set a value to attribute act.
	 * @param act.
	 */
	public void setAct(POCDMT000040Act act) {
	    this.act = act;
	}
	
	
	
	
	/**
	 * Return encounter.
	 * @return encounter
	 */
	public POCDMT000040Encounter getEncounter() {
	    return encounter;
	}
	
	/**
	 * Set a value to attribute encounter.
	 * @param encounter.
	 */
	public void setEncounter(POCDMT000040Encounter encounter) {
	    this.encounter = encounter;
	}
	
	
	
	
	/**
	 * Return observation.
	 * @return observation
	 */
	public POCDMT000040Observation getObservation() {
	    return observation;
	}
	
	/**
	 * Set a value to attribute observation.
	 * @param observation.
	 */
	public void setObservation(POCDMT000040Observation observation) {
	    this.observation = observation;
	}
	
	
	
	
	/**
	 * Return observationMedia.
	 * @return observationMedia
	 */
	public POCDMT000040ObservationMedia getObservationMedia() {
	    return observationMedia;
	}
	
	/**
	 * Set a value to attribute observationMedia.
	 * @param observationMedia.
	 */
	public void setObservationMedia(POCDMT000040ObservationMedia observationMedia) {
	    this.observationMedia = observationMedia;
	}
	
	
	
	
	/**
	 * Return organizer.
	 * @return organizer
	 */
	public POCDMT000040Organizer getOrganizer() {
	    return organizer;
	}
	
	/**
	 * Set a value to attribute organizer.
	 * @param organizer.
	 */
	public void setOrganizer(POCDMT000040Organizer organizer) {
	    this.organizer = organizer;
	}
	
	
	
	
	/**
	 * Return procedure.
	 * @return procedure
	 */
	public POCDMT000040Procedure getProcedure() {
	    return procedure;
	}
	
	/**
	 * Set a value to attribute procedure.
	 * @param procedure.
	 */
	public void setProcedure(POCDMT000040Procedure procedure) {
	    this.procedure = procedure;
	}
	
	
	
	
	/**
	 * Return regionOfInterest.
	 * @return regionOfInterest
	 */
	public POCDMT000040RegionOfInterest getRegionOfInterest() {
	    return regionOfInterest;
	}
	
	/**
	 * Set a value to attribute regionOfInterest.
	 * @param regionOfInterest.
	 */
	public void setRegionOfInterest(POCDMT000040RegionOfInterest regionOfInterest) {
	    this.regionOfInterest = regionOfInterest;
	}
	
	
	
	
	/**
	 * Return substanceAdministration.
	 * @return substanceAdministration
	 */
	public POCDMT000040SubstanceAdministration getSubstanceAdministration() {
	    return substanceAdministration;
	}
	
	/**
	 * Set a value to attribute substanceAdministration.
	 * @param substanceAdministration.
	 */
	public void setSubstanceAdministration(POCDMT000040SubstanceAdministration substanceAdministration) {
	    this.substanceAdministration = substanceAdministration;
	}
	
	
	
	
	/**
	 * Return supply.
	 * @return supply
	 */
	public POCDMT000040Supply getSupply() {
	    return supply;
	}
	
	/**
	 * Set a value to attribute supply.
	 * @param supply.
	 */
	public void setSupply(POCDMT000040Supply supply) {
	    this.supply = supply;
	}
	
	
	
	
	/**
	 * Return contextConductionInd.
	 * @return contextConductionInd
	 */
	public Boolean getContextConductionInd() {
	    return contextConductionInd;
	}
	
	/**
	 * Set a value to attribute contextConductionInd.
	 * @param contextConductionInd.
	 */
	public void setContextConductionInd(Boolean contextConductionInd) {
	    this.contextConductionInd = contextConductionInd;
	}
	
	
	/**
	 * Return contextConductionInd.
	 * @return contextConductionInd
	 * Generated for the use on jsf pages
	 */
	 @Deprecated
	public Boolean isContextConductionInd() {
	    return contextConductionInd;
	}
	
	/**
	 * Return nullFlavor.
	 * @return nullFlavor
	 */
	public net.ihe.gazelle.voc.NullFlavor getNullFlavor() {
	    return nullFlavor;
	}
	
	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor.
	 */
	public void setNullFlavor(net.ihe.gazelle.voc.NullFlavor nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}
	
	
	
	
	/**
	 * Return typeCode.
	 * @return typeCode
	 */
	public net.ihe.gazelle.voc.ActRelationshipHasComponent getTypeCode() {
	    return typeCode;
	}
	
	/**
	 * Set a value to attribute typeCode.
	 * @param typeCode.
	 */
	public void setTypeCode(net.ihe.gazelle.voc.ActRelationshipHasComponent typeCode) {
	    this.typeCode = typeCode;
	}
	
	
	
	
	/**
	 * Return __parent.
	 * @return __parent
	 */
	public Object get__parent() {
	    return __parent;
	}
	
	/**
	 * Set a value to attribute __parent.
	 * @param __parent.
	 */
	public void set__parent(Object __parent) {
	    this.__parent = __parent;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.cdaepsos4");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "POCD_MT000040.Component4").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(POCDMT000040Component4 pOCDMT000040Component4, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (pOCDMT000040Component4 != null){
   			cvm.validate(pOCDMT000040Component4, _location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CS realmCode: pOCDMT000040Component4.getRealmCode()){
					net.ihe.gazelle.datatypes.CS.validateByModule(realmCode, _location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			POCDMT000040InfrastructureRootTypeId.validateByModule(pOCDMT000040Component4.getTypeId(), _location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.II templateId: pOCDMT000040Component4.getTemplateId()){
					net.ihe.gazelle.datatypes.II.validateByModule(templateId, _location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.datatypes.INT.validateByModule(pOCDMT000040Component4.getSequenceNumber(), _location + "/sequenceNumber", cvm, diagnostic);
			net.ihe.gazelle.datatypes.BL.validateByModule(pOCDMT000040Component4.getSeperatableInd(), _location + "/seperatableInd", cvm, diagnostic);
			POCDMT000040Act.validateByModule(pOCDMT000040Component4.getAct(), _location + "/act", cvm, diagnostic);
			POCDMT000040Encounter.validateByModule(pOCDMT000040Component4.getEncounter(), _location + "/encounter", cvm, diagnostic);
			POCDMT000040Observation.validateByModule(pOCDMT000040Component4.getObservation(), _location + "/observation", cvm, diagnostic);
			POCDMT000040ObservationMedia.validateByModule(pOCDMT000040Component4.getObservationMedia(), _location + "/observationMedia", cvm, diagnostic);
			POCDMT000040Organizer.validateByModule(pOCDMT000040Component4.getOrganizer(), _location + "/organizer", cvm, diagnostic);
			POCDMT000040Procedure.validateByModule(pOCDMT000040Component4.getProcedure(), _location + "/procedure", cvm, diagnostic);
			POCDMT000040RegionOfInterest.validateByModule(pOCDMT000040Component4.getRegionOfInterest(), _location + "/regionOfInterest", cvm, diagnostic);
			POCDMT000040SubstanceAdministration.validateByModule(pOCDMT000040Component4.getSubstanceAdministration(), _location + "/substanceAdministration", cvm, diagnostic);
			POCDMT000040Supply.validateByModule(pOCDMT000040Component4.getSupply(), _location + "/supply", cvm, diagnostic);
    	}
    }

}